#include <windows.h>
#include <stdio.h>
#include <iostream>
#include "shrimpscript.h"
using namespace std;

ShrimpScript ss;

void print(vector<ShrimpVariable>& runtimeStack, ShrimpVariable& result, int pcount )
{
	for (int i=pcount; i>0; i--) {
		ShrimpVariable& v = runtimeStack[runtimeStack.size()-i];
		cout << v.getString();
	}
}

void command(vector<ShrimpVariable>& runtimeStack, ShrimpVariable& result, int pcount )
{
	ShrimpVariable& v = runtimeStack.back();
	system(v.getString().c_str());
}

void message(vector<ShrimpVariable>& runtimeStack, ShrimpVariable& result, int pcount )
{
	string msg;
	for (int i=pcount; i>0; i--) {
		ShrimpVariable& v = runtimeStack[runtimeStack.size()-i];
		msg += v.getString();
	}
	MessageBoxA(0, msg.c_str(), "FakeBasic", 0);
}

void isNull(vector<ShrimpVariable>& runtimeStack, ShrimpVariable& result, int pcount )
{
	for (int i=pcount; i>0; i--) {
		ShrimpVariable& v = runtimeStack[runtimeStack.size()-i];
		if (v.type!=0) {
			result.setInteger(0);
			return;
		}
	}
	result.setInteger(1);
}

int main(int argc, char **argv)
{
	char* file = (char*)"main.fb", *entry = (char*)"MAIN";
	if (argc==3) {
		file = argv[1];
		entry = argv[2];
	} else if (argc==2) {
		file = argv[1];
	}
	ss.addFunction("print", &print);
	ss.addFunction("isNull", &isNull);
	ss.addFunction("message", &message);
	ss.addFunction("system", &command);
	if (!ss.load(file)) {
		MessageBoxA(0, ss.getLastError().c_str(), "Script Error", 0);
		return -2;
	}
	if (!ss.run(entry)) {
		MessageBoxA(0, ss.getLastError().c_str(), "Runtime Error", 0);
		return -3;
	}
	return 0;
}
